.data

coucou:
        .string "coucou\n\0aaa" 
        # Le \0aaa nous force à traiter le cas général.
        # En écrivant juste "coucou" on a implicitement
        # un octet \0 à la fin, mais aussi (souvent)
        # encore des 0 dans la mémoire après celui-ci.
        # Du coup, une détection de fin de chaîne qui
        # cherche un 0 de taille 32 ou 64 bits aurait
        # tendance à marcher.
	
.text

main:
.global main

	movq $coucou, %rdi
	call putstr

	movq $0xdeadbeef, %rdi
	call putint

	movq $0, %rdi
	call exit

# -------------------------------------------------------

putstr:
	pushq %rbp
	movq %rsp, %rbp

        # On utilise des registres "callee-saved"
        # pour nos calculs.

        movq %rdi, %r12
	movq $0, %r13

        # Tant que *(%rdi) n'est pas 0, on avance
        # dans la chaîne et incrémente %r13

l1:
	cmpb $0, (%rdi)
	je l2
	addq $1, %r13
	addq $1, %rdi
	jmp l1

l2:

        # Affichage de la chaîne originale (%r12)
        # par un appel à write

        movq %r13, %rdx
	movq %r12, %rsi
	movq $1, %rdi
	call write

	leave
	ret

# -------------------------------------------------------

.data

# Strings for putint
intpattern:
        .string "0x12341234\n"
hexdigits:
        .string "0123456789abcdef"

.text

putint:
        pushq %rbp
        movq %rsp, %rbp

        # Pour chaque demi-octet nous allons remplir le chiffre hexa
        # correspondant dans la chaine intpattern.
        # Le registre r13 servira à compter huit itérations.
        # Le registre r12 pointera vers la position courante dans intpattern;
        # on commence au 10ème caractère (intpattern+9) et on descend jusqu'au
        # 2ème..
        # Le registre edi contient l'entier à afficher; ses bits seront
        # décalés vers la droite au fur et à mesure de la conversion.
        movq $intpattern, %r12
        addq $9, %r12
        movq $0, %r13

l3:
        # On récupère le caractère *(hexdigits+al)
        movzbq %dil, %r11
        andq $0xf, %r11
        addq $hexdigits, %r11
        movb (%r11), %r11b
        movb %r11b, (%r12)
        addq $-1, %r12
        shrl $4, %edi
        # Préparation de l'étape suivante
        addq $1, %r13
        cmpq $8, %r13
        jne l3

        # Fin de la boucle, on affiche inpattern
        movq $11, %rdx
		movq $intpattern, %rsi
		movq $1, %rdi
		call write

        leave
        ret
